---
schema_version: "1"
id: 774d3013c865368e6022831e73fcdc842d87f82909b5fef0080309357630e137
title: Converged Media Process API
collection: developer
version: current
locale: en-us
portal_url: https://docs.salesforce.com/developer/current/en-us/industries-integrations/media_cloud/references/generated-api-specs/converged_media.md
canonical_url: https://developer.salesforce.com/docs/industries/media-cloud/references/converged_media
source_site: developer.salesforce.com
content_type: documentation
content_hash: fb538884bc6c6e2860d58b334a6da60d593d19d2b1470a1aeb8f22e25603adb6
products:
  - Media Cloud AdTech Integration API
  - Industries Integrations
---
Converged Media Process API

# Converged Media Process API

Use the Media Integrations APIs to integrate the Media Cloud apps with external systems.

**Version:** v1

Protocols: HTTPS.

## Operations

### POST Perform Proposal Operation

`POST /performProposalOperation`

Creates the Proposal Operation resource.

#### Request body

Media type: `application/json`. Schema: `Perform_Proposal_Operation`.

Specifies the Proposal Operation to create.

_Example_

```
{
  "requestId": "c9636ffa-bd35-f3ef-38f8-4c649a6fa33f",
  "additionalFields": {
    "additionField1": "additionField_1_Value"
  },
  "requestMode": "Minimal",
  "requestI18NInfo": {
    "localeName": "United States",
    "localeCode": "en-us",
    "timezone": "Apia Standard Time (Pacific/Apia)",
    "currencyName": "United States Dollar",
    "currencyCode": "USD"
  },
  "proposals": [
    {
      "name": "Proposal_Name",
      "startDate": "2023-07-01",
      "endDate": "2023-10-25",
      "proposalHeader": {
        "isProgrammatic": false,
        "revenueSpecs": {
          "additionalFields": {
            "additionField1": "additionField_1_Value"
          },
          "revenueTypecode": "PRORATE"
        },
        "additionalFields": {
          "additionField1": "additionField_1_Value"
        },
        "invoiceSpecs": {
          "invoiceTypeCode": "XLS",
          "additionalFields": {
            "additionField1": "additionField_1_Value"
          },
          "invoiceType": "PDF",
          "EDIProductCode": "Linear",
          "EDIClientCode": "Linear",
          "EDIOrder": "Linear"
        },
        "tags": [
          ""
        ],
        "notes": "",
        "purchaseOrderNumber": "",
        "publisherOrderName": "",
        "totalBudget": {
          "value": 100,
          "currencyName": "United States Dollar",
          "currencyCode": "USD"
        },
        "adServerHeadersbyAdServerCode": {
          "default": {
            "advertiserId": "11323"
          },
          "XG": {
            "advertiserId": "123456"
          }
        },
        "orderStatus": "",
        "billingSpecs": {
          "billingCycleTypeCode": "QRTR",
          "valueCostPerUnit": {
            "value": 100,
            "currencyName": "United States Dollar",
            "currencyCode": "USD"
          },
          "additionalFields": {
            "additionField1": "additionField_1_Value"
          },
          "billingMode": "Fractional",
          "billingCycleType": "Broadcast"
        },
        "orderType": "",
        "adServerAction": "Create",
        "deliveryDetails": {
          "additionalFields": {
            "additionField1": "additionField_1_Value"
          },
          "totalClicksDelivered": 200,
          "totalImpressionsDelivered": 20000,
          "totalViewableImpressionsDelivered": 200
        }
      },
      "lineItems": [
        {
          "proposalId": "435345345",
          "lineItemDetail": {
            "inventoryTypeCode": "DEFAULT",
            "endDate": "2023-06-26",
            "linearAttributes": {
              "additionField1": "additionField_1_Value"
            },
            "lineItemName": "10 sec skippable ad",
            "targeting": {
              "dayPartTargeting": [
                {
                  "segmentValues": [
                    {
                      "value": 0.5,
                      "label": "Hourly"
                    }
                  ],
                  "segmentCode": "SlotType",
                  "segmentName": "SlotType"
                },
                {
                  "segmentValues": [
                    {
                      "value": "Monday 00:00",
                      "label": "Monday 00:00"
                    },
                    {
                      "value": "Wednesday 00:00",
                      "label": "Wednesday 00:00"
                    },
                    {
                      "value": "Wednesday 00:30",
                      "label": "Wednesday 00:30"
                    }
                  ],
                  "segmentCode": "DayAndTime",
                  "segmentName": "DayAndTime"
                }
              ],
              "geoTargeting": [
                {
                  "segmentValues": [
                    {
                      "value": "21132",
                      "label": "Alaska"
                    }
                  ],
                  "segmentCode": "Region",
                  "segmentName": "Region"
                }
              ],
              "others": [
                {
                  "categoryCode": "xgLineAudience",
                  "categoryName": "xgLineAudience",
                  "targetingSegmentDefinition": [
                    {
                      "segmentValues": [
                        {
                          "label": "RatingGoal ",
                          "value": "1"
                        },
                        {
                          "label": "SegmentCode ",
                          "value": "test segment"
                        }
                      ],
                      "segmentCode": "2222",
                      "segmentName": "xgLineAudience"
                    }
                  ]
                },
                {
                  "categoryCode": "Audience Segment",
                  "categoryName": "Audience Segment",
                  "targetingSegmentDefinition": [
                    {
                      "segmentValues": [
                        {
                          "label": "gender",
                          "value": "female"
                        }
                      ],
                      "segmentCode": "Female",
                      "segmentName": "Gender Based"
                    }
                  ]
                }
              ]
            },
            "revenueSpecs": {
              "additionalFields": {
                "additionField1": "additionField_1_Value"
              },
              "revenueTypecode": "PRORATE"
            },
            "publisherOrderLineItemName": "",
            "additionalFields": {
              "additionField1": "additionField_1_Value"
            },
            "digitalAttributes": {
              "additionField1": "additionField_1_Value"
            },
            "id": "283718",
            "mediaChannelCode": "SONY",
            "adSpaceSpecifications": [
              {
                "adServerAdUnitId": "22214043670",
                "adServerDaypart": "00:00-23:59",
                "creatives": [
                  {
                    "height": "970",
                    "width": "70",
                    "adServerCreativeId": "283718",
                    "adServerCreativeRunTime": "400",
                    "adServerCreativeType": "Bookend",
                    "adCreativeUOM": "Pixels",
                    "companions": [
                      {
                        "key": "temp",
                        "value": {
                          "adCreativeUOM": "Pixels",
                          "width": 90,
                          "height": 120
                        }
                      }
                    ],
                    "attributes": {
                      "additionField1": "additionField_1_Value"
                    },
                    "additionalFields": {
                      "additionField1": "additionField_1_Value"
                    }
                  }
                ],
                "additionalFields": {
                  "additionField1": "additionField_1_Value"
                }
              }
            ],
            "frequencyCaps": [
              {
                "maxImpressions": 1000,
                "numTimeUnits": 5,
                "timeUnit": "Hour",
                "additionalFields": {
                  "additionField1": "additionField_1_Value"
                }
              }
            ],
            "startDate": "2023-06-26",
            "lineItemQuantity": {
              "additionalFields": {
                "additionField1": "additionField_1_Value"
              },
              "totalQuantity": 12,
              "totalQuantityPeriodType": "weekly",
              "totalQuantityType": "Impressions",
              "quantityBreakdownByDate": [
                {
                  "additionField1": "additionField_1_Value"
                }
              ]
            },
            "goals": [
              {
                "goalType": "Daily",
                "goalTypeCode": "Weekly",
                "goalUnitType": "Click",
                "goalUnitTypeCode": "Action",
                "goalUnits": 2000,
                "primary": false,
                "additionalFields": {
                  "additionField1": "additionField_1_Value"
                }
              }
            ],
            "pricingSpecs": {
              "costType": "CPM",
              "discountType": "Percentage",
              "valueCostPerUnit": {
                "value": 100,
                "currencyName": "United States Dollar",
                "currencyCode": "USD"
              },
              "additionalFields": {
                "additionField1": "additionField_1_Value"
              },
              "discount": 15,
              "costPerUnit": {
                "value": 100,
                "currencyName": "United States Dollar",
                "currencyCode": "USD"
              },
              "totalCost": {
                "value": 100,
                "currencyName": "United States Dollar",
                "currencyCode": "USD"
              },
              "mediaChannelRate": [
                {
                  "channelCode": "SONY",
                  "regionCode": "NYC",
                  "lineRate": {
                    "value": 100,
                    "currencyName": "United States Dollar",
                    "currencyCode": "USD"
                  }
                }
              ]
            },
            "adServerCode": "GAM",
            "adServerInstanceId": "22773096281",
            "lineItemType": "STANDARD",
            "billingSpecs": {
              "additionalFields": {
                "additionField1": "additionField_1_Value"
              },
              "billingModeTypeCode": "Usage",
              "billingModeType": "Threshold"
            },
            "adServerAction": "Create"
          },
          "lineItemPriority": 2,
          "deliveryRateType": "EVENLY",
          "videoAttributes": {
            "maxDuration": 100,
            "skippable": "Enabled",
            "displayCompanions": "AtLeastOne"
          },
          "audioAttributes": {
            "maxDuration": 100,
            "skippable": "Enabled",
            "displayCompanions": "AtLeastOne"
          },
          "displayAttributes": {
            "additionField1": "additionField_1_Value"
          },
          "attributes": {
            "additionField1": "additionField_1_Value"
          },
          "additionalFields": {
            "additionField1": "additionField_1_Value"
          }
        }
      ],
      "attributes": {
        "additionField1": "additionField_1_Value"
      },
      "additionalFields": {
        "additionField1": "additionField_1_Value"
      }
    }
  ],
  "requestedBy": "Bianca White"
}
```

#### Responses

*   **200** Created the Proposal Operation resource.
    
    Media type: `application/json`. Schema: `Perform_Proposal_Operation_Response`.
    
    _Example_
    
    ```
    {
      "requestId": "RQST00001",
      "requestedBy": "Bianca White",
      "adServerInstanceId": "INS0491001",
       "result": {
        "code": 200,
        "status": "success"
      },
      "minimalResults" : ["101"],
      "detailResults" : [],
      "stepwiseResults" : [{
        "systemApiEndPoint" : "/proposal",
        "result" : {
          "id" : "56736573",
          "name" : "media plan 101",
          "status" : "success",
          "operatingOn" : "Proposal"
        },
        "adServer" : {
          "adServerInstanceId" : "XG",
          "adServerCode" : "xglinear",
          "adServerApplicationName" : "NoName",
          "mediaType" : "xglinear"},
        "status" : "success"
      }],
      "additionalFields": 
        {
          "contractId": "additionField1"
        }
      
    }
    ```
    
*   **400** There was an issue with your request.
    
    Media type: `application/json`. Schema: `ErrorMessage`.
    
    _Example_
    
    ```
    {
    	"requestId": "RQST00001",
    	"requestedBy": "Bianca White",
    	"adServerInstanceId": "INS0491001",
    	"result": {
    		"status": "error",
        "code": 400,
    		"adServerLogId": "54uy-213i-9489-3121",
        "shortMessage": "BAD_REQUEST",
        "verboseMessage": "Errors: /items/0 required key [startDate] not found."
    	},
    	"minimalResults": [],
    	"detailResults": [],
    	"additionalFields": []
    }
    ```
    
*   **401** Authorization failed.
    
    Media type: `application/json`. Schema: `ErrorMessage`.
    
    _Example_
    
    ```
    {
    	"requestId": "RQST00001",
    	"requestedBy": "Bianca White",
    	"adServerInstanceId": "INS0491001",
    	"result": {
    		"status": "error",
        "code": 401,
    		"adServerLogId": "54uy-213i-9489-3121",
        "shortMessage": "Unauthorised",
        "verboseMessage": "Credentials are incorrect."
    	},
    	"minimalResults": [],
    	"detailResults": [],
    	"additionalFields": []
    }
    ```
    
*   **403** Request forbidden.
    
    Media type: `application/json`. Schema: `ErrorMessage`.
    
    _Example_
    
    ```
    {
    	"requestId": "RQST00001",
    	"requestedBy": "Bianca White",
    	"adServerInstanceId": "INS0491001",
    	"result": {
    		"status": "error",
        "code": 403,
    		"adServerLogId": "54uy-213i-9489-3121",
        "shortMessage": "Forbidden",
        "verboseMessage": "Request forbidden."
    	},
    	"minimalResults": [],
    	"detailResults": [],
    	"additionalFields": []
    }
    ```
    
*   **404** Resource not found.
    
    Media type: `application/json`. Schema: `ErrorMessage`.
    
    _Example_
    
    ```
    {
    	"requestId": "RQST00001",
    	"requestedBy": "Bianca White",
    	"adServerInstanceId": "INS0491001",
    	"result": {
    		"status": "error",
        "code": 404,
    		"adServerLogId": "54uy-213i-9489-3121",
        "shortMessage": "NotFound",
        "verboseMessage": "Resource not found."
    	},
    	"minimalResults": [],
    	"detailResults": [],
    	"additionalFields": []
    }
    ```
    
*   **405** Method not allowed.
    
    Media type: `application/json`. Schema: `ErrorMessage`.
    
    _Example_
    
    ```
    {
    	"requestId": "RQST00001",
    	"requestedBy": "Bianca White",
    	"adServerInstanceId": "INS0491001",
    	"result": {
    		"status": "error",
        "code": 405,
    		"adServerLogId": "54uy-213i-9489-3121",
        "shortMessage": "Method Not Allowed",
        "verboseMessage": "Method not allowed for this resource."
    	},
    	"minimalResults": [],
    	"detailResults": [],
    	"additionalFields": []
    }
    ```
    
*   **415** Unsupported media type.
    
    Media type: `application/json`. Schema: `ErrorMessage`.
    
    _Example_
    
    ```
    {
    	"requestId": "RQST00001",
    	"requestedBy": "Bianca White",
    	"adServerInstanceId": "INS0491001",
    	"result": {
    		"status": "error",
        "code": 415,
    		"adServerLogId": "54uy-213i-9489-3121",
        "shortMessage": "Unsupported Media Type",
        "verboseMessage": "Requested media type not supported."
    	},
    	"minimalResults": [],
    	"detailResults": [],
    	"additionalFields": []
    }
    ```
    
*   **422** Unprocessable entity.
    
    Media type: `application/json`. Schema: `ErrorMessage`.
    
    _Example: same as POST /performProposalOperation 415 response._
    
*   **500** Unable to complete the request as the server encountered an error.
    
    Media type: `application/json`. Schema: `ErrorMessage`.
    
    _Example: same as POST /performProposalOperation 405 response._
    

### POST Get Proposal Status

`POST /getProposalStatus`

Creates the Proposal Status resource.

#### Request body

Media type: `application/json`. Schema: `Get_Proposal_Status`.

Specifies the Proposal Status to create.

_Example_

```
{
  "requestId": "c9636ffa-bd35-f3ef-38f8-4c649a6fa33f",
  "requestedBy": "Bianca White",
  "requestI18NInfo": {
    "localeName": "United States",
    "localeCode": "en-us",
    "timezone": "Apia Standard Time (Pacific/Apia)",
    "currencyName": "United States Dollar",
    "currencyCode": "USD"
  },
  "requestMode": "Minimal",
  "proposalIds": [
    {
      "operatingOn": "Proposal",
      "adServer": {
        "adServerCode": "GAM",
        "mediaType": "Digital",
        "adServerInstanceId": "22773096280",
        "adServerApplicationName": "GAM_Sandbox_360"
      },
      "id": "54321"
    },
    {
      "operatingOn": "Proposal",
      "adServer": {
        "adServerCode": "GAM",
        "mediaType": "Digital",
        "adServerInstanceId": "22773096280",
        "adServerApplicationName": "GAM_Sandbox_360"
      },
      "id": "12345"
    }
  ],
  "additionalFields": {
    "additionField1": "additionField_1_Value"
  }
}
```

#### Responses

*   **200** Created the Proposal Status resource.
    
    Media type: `application/json`. Schema: `Get_Proposal_Status_Response`.
    
    _Example_
    
    ```
    {
      "requestId": "RQST00001",
      "requestedBy": "Bianca White",
       "result": {
        "code": 200,
        "status": "success"
      },
      "minimalResults": [
        {
          "id": "56736573",
          "name": "Media plan 101",
          "status": "Draft",
          "operatingOn": "Proposal",
          "additionalFields": {
            "additionalField1": "additionField1"
          }
        },
        {
          "id": "56736580",
          "name": "Media Plan 200",
          "status": "Approved",
          "operatingOn": "Order",
          "additionalFields": {
            "additionalField1": "additionField1"
          }
        }
      ],
      "detailResults" : [
        {
          "id": "56736573",
          "name": "Media plan 101",
          "status": "Draft",
          "operatingOn": "Proposal",
          "additionalFields": {
            "additionalField1": "additionField1"
          }
        },
        {
          "id": "56736580",
          "name": "Media Plan 200",
          "status": "Approved",
          "operatingOn": "Order",
          "additionalFields": {
            "additionalField1": "additionField1"
          }
        }
      ],
      "stepwiseResults" : [{
          "systemApiEndPoint" : "/proposal",
          "result": {
              "code": 200,
              "status": "success"
          },
          "adServer" : {
            "adServerInstanceId" : "XG",
            "adServerCode" : "xglinear",
            "adServerApplicationName" : "NoName",
            "mediaType" : "xglinear"
          },
          "status" : "success"
        }],
      "additionalFields": {
        "contractId": "additionField1"
      } 
    }
    ```
    
*   **400** There was an issue with your request.
    
    Media type: `application/json`. Schema: `ErrorMessage`.
    
    _Example: same as POST /performProposalOperation 400 response._
    
*   **401** Authorization failed.
    
    Media type: `application/json`. Schema: `ErrorMessage`.
    
    _Example: same as POST /performProposalOperation 401 response._
    
*   **403** Request forbidden.
    
    Media type: `application/json`. Schema: `ErrorMessage`.
    
    _Example: same as POST /performProposalOperation 403 response._
    
*   **404** Resource not found.
    
    Media type: `application/json`. Schema: `ErrorMessage`.
    
    _Example: same as POST /performProposalOperation 404 response._
    
*   **405** Method not allowed.
    
    Media type: `application/json`. Schema: `ErrorMessage`.
    
    _Example: same as POST /performProposalOperation 405 response._
    
*   **415** Unsupported media type.
    
    Media type: `application/json`. Schema: `ErrorMessage`.
    
    _Example: same as POST /performProposalOperation 415 response._
    
*   **422** Unprocessable entity.
    
    Media type: `application/json`. Schema: `ErrorMessage`.
    
    _Example: same as POST /performProposalOperation 415 response._
    
*   **500** Unable to complete the request as the server encountered an error.
    
    Media type: `application/json`. Schema: `ErrorMessage`.
    
    _Example: same as POST /performProposalOperation 405 response._
    

## Schemas

### Perform\_Proposal\_Operation

*   `requestId` (_string_, required) Specifies a unique identifier for a request.  
    Example: `c9636ffa-bd35-f3ef-38f8-4c649a6fa33f`.
*   `requestedBy` (_string_, required) Specifies the account or user by whom the request is initiated.  
    Example: `Bianca White`.
*   `requestI18NInfo` (_object_) Specifies details about the locale, timezone, and currency configuration, which are used by the request.
    
    Includes all fields of `I18NInfo`.
    
*   `requestMode` (_string_, required) Specifies whether the response to receive is minimal or detailed. Valid values are 'Minimal' and 'Detail'.  
    Allowed values: `Minimal`, `Detail`. Example: `Minimal`.
*   `proposals` (_array of object_, required) Contains list of proposals along with each proposal's line items list  
    Minimum items: 1.
    
    Includes all fields of `ProcessProposal`.
    
*   `additionalFields` (_object_) Specifies the additional data to be sent.
    
    Includes all fields of `KeyValuePair`.
    

### Perform\_Proposal\_Operation\_Response

*   `requestId` (_string_, required) Specifies the unique identifier for the request.  
    Example: `RQST00001`.
*   `requestedBy` (_string_, required) Specifies the account or user by whom the request is initiated.  
    Example: `Bianca White`.
*   `adServerInstanceId` (_string_, required) Specifies the instance identifier of the AD server.  
    Example: `INS0491001`.
*   `result` (_object_, required) Represents a standard result.
    
    Includes all fields of `Result`.
    
    _Example_
    
    ```
    {
      "status": "success",
      "code": 200
    }
    ```
    
*   `minimalResults` (_array of string_) Specifies the minimal response.
    
    _Example_
    
    ```
    - "11013482"
    ```
    
*   `detailResults` (_array of object_) Specifies the detailed response.
    
    Includes all fields of `OperationResult`.
    
*   `stepwiseResults` (_array of object_) Stepwise results.
    
    Includes all fields of `AdServerOperationResult`.
    
*   `additionalFields` (_object_) Specifies the additional data to be sent.
    
    Includes all fields of `KeyValuePair`.
    

### ErrorMessage

Shown when an API throws an error, typically with an HTTP error response code (3xx, 4xx, or 5xx).

*   `requestId` (_string_, required) Specifies a unique identifier for a request.  
    Example: `RQST00001`.
*   `requestedBy` (_string_, required) Specifies the account or user by whom the request is initiated.  
    Example: `Bianca White`.
*   `adServerInstanceId` (_string_, required) Specifies the instance identifier of the AD server.  
    Example: `INS0491001`.
*   `result` (_object_, required) Specifies the metadata of a error payload.
    
    Includes all fields of `Result`.
    
*   `minimalResults` (_array of any_) Specifies the minimal response.
    
    _Example_
    
    ```
    []
    ```
    
*   `detailResults` (_array of any_) Specifies the detailed response.
    
    _Example_
    
    ```
    []
    ```
    
*   `additionalFields` (_array of any_) Specifies the additional data to be sent.
    
    _Example_
    
    ```
    []
    ```
    

### Get\_Proposal\_Status

*   `requestId` (_string_, required) Specifies a unique identifier for a request.  
    Example: `c9636ffa-bd35-f3ef-38f8-4c649a6fa33f`.
*   `requestedBy` (_string_, required) Specifies the account or user by whom the request is initiated.  
    Example: `Bianca White`.
*   `requestI18NInfo` (_object_) Specifies details about the locale, timezone, and currency configuration, which are used by the request.
    
    Includes all fields of `I18NInfo`.
    
*   `requestMode` (_string_, required) Specifies whether the response to receive is minimal or detailed. Valid values are 'Minimal' and 'Detail'.  
    Allowed values: `Minimal`, `Detail`. Example: `Minimal`.
*   `proposalIds` (_array of object_, required) List of unique Ids of proposals with the ad server to which the proposal belongs to.
    
    Includes all fields of `OperationRequest`.
    
*   `additionalFields` (_object_) Specifies the additional data to be sent.
    
    Includes all fields of `KeyValuePair`.
    

### Get\_Proposal\_Status\_Response

*   `requestId` (_string_, required) Specifies the unique identifier for the request.  
    Example: `RQST00001`.
*   `requestedBy` (_string_, required) Specifies the account or user by whom the request is initiated.  
    Example: `Bianca White`.
*   `adServerInstanceId` (_string_) Specifies the instance identifier of the AD server.  
    Example: `INS0491001`.
*   `result` (_object_, required) Represents a standard result.
    
    Includes all fields of `Result`.
    
    _Example_
    
    ```
    {
      "status": "success",
      "code": 200
    }
    ```
    
*   `minimalResults` (_array of object_) Specifies the minimal response.
    
    Includes all fields of `OperationStatus`.
    
*   `detailResults` (_array of object_) Specifies the detailed response.
    
    Includes all fields of `OperationStatus`.
    
*   `stepwiseResults` (_array of object_) Stepwise results.
    
    Includes all fields of `AdServerOperationResult`.
    
*   `additionalFields` (_object_) Specifies the additional data to be sent.
    
    Includes all fields of `KeyValuePair`.
    

### I18NInfo

Represents the I18N information for a request.

*   `localeCode` (_string_) Specifies the locale code of a request.  
    Example: `en-us`.
*   `localeName` (_string_) Specifies the locale name of a request.  
    Example: `United States`.
*   `currencyCode` (_string_) Specifies the currency code used in a request payload.  
    Example: `USD`.
*   `currencyName` (_string_) Specifies the currency name related to a currencyCode property that's used in a request.  
    Example: `United States Dollar`.
*   `timezone` (_string_) Specifies the timezone of a request.  
    Example: `Apia Standard Time (Pacific/Apia)`.

### ProcessProposal

Specifies the details of a proposal

*   `name` (_string_, required) Specifies the name of the proposal.  
    Example: `Proposal_Name`.
*   `startDate` (_date-only_, required) Specifies the start date of the proposal.  
    Example: `2023-07-01`.
*   `endDate` (_date-only_, required) Specifies the end date of the proposal.  
    Example: `2023-10-25`.
*   `proposalHeader` (_object_, required) Specifies the detailed information of the proposal.
    
    Includes all fields of `ProcessOrderHeader`.
    
*   `lineItems` (_array of object_) Specifies the details of proposal line items associated with a proposal.
    
    Includes all fields of `ProcessProposalLineItem`.
    
*   `attributes` (_object_) Specifies the additional metadata or custom information.
    
    Includes all fields of `KeyValuePair`.
    
*   `additionalFields` (_object_) Specifies the additional metadata or custom information.
    
    Includes all fields of `KeyValuePair`.
    

### KeyValuePair

Specifies a key-value pair map.

*   `additionField1` (_any_) Specifies the additionField1.
    
    _Example_
    
    ```
    additionField_1_Value
    ```
    

### Result

Specifies the metadata of a response payload.

*   `status` (_string_)  
    Allowed values: `success`, `error`.
*   `code` (_integer_) A set of predefined codes similar to http status codes to indicate business rule violation
*   `adServerLogId` (_string_) Unique logid tied to this request for troubleshooting
*   `shortMessage` (_string_) if request mode is minimal send atleast the minimum information required to understand a error case
*   `verboseMessage` (_string_) if request mode is detail send verboseinformation required to understand a error case

### OperationResult

Specifies the details of a operation result.

*   `result` (_object_, required) specifies the status of parent object
    
    Includes all fields of `OperationStatus`.
    
*   `lineItemResults` (_array of object_) specifies the status of parent object
    
    Includes all fields of `OperationStatus`.
    
*   `additionalFields` (_object_) Specifies the additional metadata or custom information.
    
    Includes all fields of `KeyValuePair`.
    

### AdServerOperationResult

Specifies the details of a operation result.

*   `systemApiEndPoint` (_string_) Endpoint name for System api step
*   `result` (_object_, required) specifies the status of parent object
*   `adServer` (_object_, required) specifies the status of parent object
    
    Includes all fields of `AdServer`.
    
*   `status` (_string_) specifies the status of line items associated with parent object  
    Example: `200`.
*   `additionalFields` (_object_) Specifies the additional metadata or custom information.
    
    Includes all fields of `KeyValuePair`.
    

### OperationRequest

Specifies the details of a operation request.

*   `id` (_string_, required) Specifies the id of the object.  
    Example: `123456`.
*   `adServer` (_object_, required) Specifies the adserver details.
    
    Includes all fields of `AdServer`.
    
*   `operatingOn` (_string_, required) Specifies the object being operated upon.  
    Example: `Proposal`.

### OperationStatus

Specifies the status of operation on an object like Order, OrderLineItem, Proposal, ProposalLineItem etc.

*   `id` (_string_, required) specifies the id of the object  
    Example: `56736573`.
*   `name` (_string_) specifies the name of the object  
    Example: `media plan 101`.
*   `status` (_string_, required) specifies the status of the object  
    Example: `Draft`.
*   `operatingOn` (_string_, required) specifies the object being operated upon  
    Example: `Proposal`.
*   `additionalFields` (_object_) Specifies the additional metadata or custom information.
    
    Includes all fields of `KeyValuePair`.
    

### ProcessOrderHeader

Specifies the detailed information of an order like pricing specs, billing specs, etc.

*   `revenueSpecs` (_object_) Specifies the details related to the revenue of an order.
    
    Includes all fields of `RevenueSpecs`.
    
*   `billingSpecs` (_object_) Specifies the details related to the billing of an order.
    
    Includes all fields of `OrderBillingSpecs`.
    
*   `invoiceSpecs` (_object_) Specifies the details related to the invoice of an order.
    
    Includes all fields of `Invoicespecs`.
    
*   `purchaseOrderNumber` (_string_) Specifies the purchase order number of an order.
*   `publisherOrderName` (_string_) Specifies the purchase order name of an order.
*   `orderStatus` (_string_) Specifies the status of an order.
*   `orderType` (_string_) Specifies the type of an order.
*   `deliveryDetails` (_object_) Specifies the details related to the delivery of an order like clicks, impressions, etc.
    
    Includes all fields of `DeliverySpecs`.
    
*   `tags` (_array of string_) Specifies the custom keywords/labels related to an order that can be used for search or other purposes.
*   `totalBudget` (_object_) Specifies the overall budget allocated to an order
    
    Includes all fields of `CurrencyInfo`.
    
*   `isProgrammatic` (_boolean_) Specifies the value denoting if the order is of progammatic type.  
    Example: `false`.
*   `notes` (_string_) Specifies the additional notes or memo related to an order.
*   `additionalFields` (_object_) Specifies the additional metadata or custom information.
    
    Includes all fields of `KeyValuePair`.
    
*   `adServerHeadersbyAdServerCode` (_object_, required) Specifies the additional notes or memo related to an order.
    
    _Example_
    
    ```
    {
      "default":{
     "advertiserId": "11323"
    },
    "XG":
    {
    "advertiserId":"123456"
    }
    }
    ```
    
*   `adServerAction` (_string_, required) Action for Order  
    Allowed values: `Create`, `Update`, `OpenForEdit`, `Other`, `None`. Example: `Create`.

### ProcessProposalLineItem

Specifies the details of a proposal line item.

*   `proposalId` (_string_, required) specifies the id of the proposal with which the proposal line item is associated.  
    Example: `435345345`.
*   `lineItemDetail` (_object_, required) specifies detailed information of the proposal line item
    
    Includes all fields of `ProcessOrderLineItem`.
    
*   `lineItemPriority` (_integer_) specifies the priority of the line item  
    Example: `2`.
*   `deliveryRateType` (_string_) specifies the id of the proposal with which the proposal line item is associated.  
    Example: `EVENLY`.
*   `videoAttributes` (_object_) specifies the specific details related to the proposal line item of video type.
    
    Includes all fields of `KeyValuePair`.
    
    _Example_
    
    ```
    {
    "maxDuration": 100.00,
    "skippable": "Enabled",
    "displayCompanions":"AtLeastOne"
    }
    ```
    
*   `audioAttributes` (_object_) specifies the specific details related to the proposal line item of audio type.
    
    Includes all fields of `KeyValuePair`.
    
    _Example_
    
    ```
    {
    "maxDuration": 100.00,
    "skippable": "Enabled",
    "displayCompanions":"AtLeastOne"
    }
    ```
    
*   `displayAttributes` (_object_) specifies the specific details related to the proposal line item of display type.
    
    Includes all fields of `KeyValuePair`.
    
*   `attributes` (_object_) Specifies the additional metadata or custom information.
    
    Includes all fields of `KeyValuePair`.
    
*   `additionalFields` (_object_) Specifies the additional metadata or custom information.
    
    Includes all fields of `KeyValuePair`.
    

### AdServer

Specifies the metadata of a response payload.

*   `adServerInstanceId` (_string_, required) Identifier for the AdServer for e,g for GAM its the unique networkcode  
    Example: `GAM`.
*   `adServerCode` (_string_, required) dServer Code is used to identify the type of Adserver.E.g values are gam or xglinear  
    Example: `xglinear`.
*   `adServerApplicationName` (_string_) Adserver application name  
    Example: `NoName`.
*   `mediaType` (_string_) dServer Code is used to identify the type of Adserver.E.g values are gam or xglinear  
    Example: `xglinear`.

### RevenueSpecs

Specifies the revenue specifications of a line item.

*   `revenueTypecode` (_string_) Specifies the code of the revenue type.  
    Example: `PRORATE`.
*   `additionalFields` (_object_) Specifies the additional metadata or custom information.
    
    Includes all fields of `KeyValuePair`.
    

### OrderBillingSpecs

Specifies the billing specifications for an order.

*   `billingCycleType` (_string_) Specifies the billing cycle of the order.  
    Example: `Broadcast`.
*   `billingCycleTypeCode` (_string_) Specifies the unique code for the billing cycle of the order if the type is not specified by the billingCycleType.  
    Example: `QRTR`.
*   `billingMode` (_string_) Specifies the billing mode of an order.  
    Example: `Fractional`.
*   `additionalFields` (_object_) Specifies the additional metadata or custom information.
    
    Includes all fields of `KeyValuePair`.
    
*   `valueCostPerUnit` (_object_) Cost per Unit
    
    Includes all fields of `CurrencyInfo`.
    

### Invoicespecs

Specifies the invoice specifications of an order.

*   `invoiceType` (_string_) Specifies the invoice type of an order.  
    Allowed values: `PDF`, `EDI`, `Other`. Example: `PDF`.
*   `invoiceTypeCode` (_string_) Specifies the invoice type of an order if the invoiceType is "Others".  
    Example: `XLS`.
*   `EDIProductCode` (_string_) Specifies the product code of the invoice if the invoice type is EDI.  
    Example: `Linear`.
*   `EDIOrder` (_string_) Specifies the product code of the invoice if the invoice type is EDI.  
    Example: `Linear`.
*   `EDIClientCode` (_string_) Specifies the client code if the invoice type is EDI.  
    Example: `Linear`.
*   `additionalFields` (_object_) Specifies the additional metadata or custom information.
    
    Includes all fields of `KeyValuePair`.
    

### DeliverySpecs

Specifies the delivery specifications of an order.

*   `totalImpressionsDelivered` (_number_) Specifies the total impressions delivered for an order.  
    Example: `20000`.
*   `totalClicksDelivered` (_number_) Specifies the total clicks delivered in an order.  
    Example: `200`.
*   `totalViewableImpressionsDelivered` (_number_) Specifies the total viewable impressions delivered for an order.  
    Example: `200`.
*   `additionalFields` (_object_) Specifies the additional metadata or custom information.
    
    Includes all fields of `KeyValuePair`.
    

### CurrencyInfo

Specifies the information about a currency field used in a request payload.

*   `value` (_number_) Specifies the value of the currency field.  
    Example: `100`.
*   `currencyCode` (_string_) Specifies the code of the currency field.  
    Example: `USD`.
*   `currencyName` (_string_) Specifies the name of the currency as defined by the currencyCode.  
    Example: `United States Dollar`.

### ProcessOrderLineItem

Specifies the details of a line item.

*   `id` (_string_) Specifies the unique identifier of a line item.  
    Example: `283718`.
*   `lineItemName` (_string_, required) Specifies the name of a line item  
    Example: `10 sec skippable ad`.
*   `startDate` (_date-only_, required) Specifies the start date of the order.  
    Example: `2023-06-26`.
*   `endDate` (_date-only_) Specifies the end date of the order.  
    Example: `2023-06-26`.
*   `lineItemType` (_string_) Specifies the type of a line item. A line item type can denote the priority of a line item.  
    Example: `STANDARD`.
*   `mediaChannelCode` (_string_) Specifies the name of the channel of a line item.  
    Example: `SONY`.
*   `adSpaceSpecifications` (_array of AdSpaceSpecification_, required) Specifies a specific place or a group of places where an Advertisement (AD) creative is served.  
    Maximum items: 1.
*   `targeting` (_object_) Specifies the AD target details, such as geoTargeting and dayPartTargeting.
    
    Includes all fields of `Targeting`.
    
    _Example_
    
    ```
    {
    	"dayPartTargeting": [{
    		"segmentValues": [{
    			"value": 0.5,
    			"label": "Hourly"
    		}],
    		"segmentCode": "SlotType",
    		"segmentName": "SlotType"
    	}, {
    		"segmentValues": [{
    			"value": "Monday 00:00",
    			"label": "Monday 00:00"
    		}, {
    			"value": "Wednesday 00:00",
    			"label": "Wednesday 00:00"
    		}, {
    			"value": "Wednesday 00:30",
    			"label": "Wednesday 00:30"
    		}],
    		"segmentCode": "DayAndTime",
    		"segmentName": "DayAndTime"
    	}],
    	"geoTargeting": [{
    		"segmentValues": [{
    			"value": "21132",
    			"label": "Alaska"
    		}],
    		"segmentCode": "Region",
    		"segmentName": "Region"
    	}],
    
    	"others": [{
    			"categoryCode": "xgLineAudience",
    			"categoryName": "xgLineAudience",
    			"targetingSegmentDefinition": [{
    				"segmentValues": [{
    					"label": "RatingGoal ",
    					"value": "1"
    				}, {
    					"label": "SegmentCode ",
    					"value": "test segment"
    				}],
    				"segmentCode": "2222",
    				"segmentName": "xgLineAudience"
    			}]
    		},
    		{
    			"categoryCode": "Audience Segment",
    			"categoryName": "Audience Segment",
    			"targetingSegmentDefinition": [{
    				"segmentValues": [{
    					"label": "gender",
    					"value": "female"
    				}],
    				"segmentCode": "Female",
    				"segmentName": "Gender Based"
    			}]
    		}
    	]
    }
    ```
    
*   `frequencyCaps` (_array of object_)
    
    Includes all fields of `FrequencyCaps`.
    
*   `pricingSpecs` (_object_, required) Specifies the details related to the pricing of a line item.
    
    Includes all fields of `PricingSpecs`.
    
*   `publisherOrderLineItemName` (_string_) Line item name.
*   `billingSpecs` (_object_) Specifies the details related to the billing of a line item.
    
    Includes all fields of `OrderLineBillingSpecs`.
    
*   `goals` (_array of object_) Specifies the user engagement goal information related to a line item.
    
    Includes all fields of `Goal`.
    
*   `lineItemQuantity` (_object_, required) Specifies the details related to the requested units to an AD server.
    
    Includes all fields of `LineItemQuantity`.
    
*   `inventoryTypeCode` (_string_) Specifies the code of the inventory type. The default value is DEFAULT.  
    Default: `DEFAULT`.
*   `linearAttributes` (_object_) Specifies any additional or custom attributes to be sent for linear media type.
    
    Includes all fields of `KeyValuePair`.
    
*   `revenueSpecs` (_object_) Specifies the details related to the revenue line item.
    
    Includes all fields of `RevenueSpecs`.
    
*   `digitalAttributes` (_object_) Specifies any additional or custom attributes to be sent for digital media type.
    
    Includes all fields of `KeyValuePair`.
    
*   `additionalFields` (_object_) Specifies the additional metadata or custom information.
    
    Includes all fields of `KeyValuePair`.
    
*   `adServerCode` (_string_) AdServerCode
*   `adServerAction` (_string_) Specifies the action for line item  
    Example: `Create`.
*   `adServerInstanceId` (_string_) Specifies the instance id of adserver  
    Example: `22773096281`.

### AdSpaceSpecification

Specifies the details of an AD space spec or an AD unit corresponding to a line item.

*   `adServerAdUnitId` (_string_, required) Specifies the unique identifier of an AD space spec.  
    Example: `22214043670`.
*   `adServerDaypart` (_string_) Specifies the start and end time of the ad space spec in a format.  
    Example: `00:00-23:59`.
*   `creatives` (_array of object_, required) Specifies the list of AD creatives related to an AD space spec.
    
    Includes all fields of `AdCreatives`.
    
*   `additionalFields` (_object_) Specifies the additional metadata or custom information.
    
    Includes all fields of `KeyValuePair`.
    

### Targeting

Specifies the target details, such as geotargeting and daypart targeting.

*   `geoTargeting` (_array of object_) Specifies the targeting specs for a geographic area.
    
    Includes all fields of `TargetSegmentItem`.
    
*   `dayPartTargeting` (_array of object_) Specifies the targeting specs for a part of the day.
    
    Includes all fields of `TargetSegmentItem`.
    
*   `others` (_array of object_) Specifies the other targeting specs.
    
    Includes all fields of `CustomTargetingDefinition`.
    
*   `additionalFields` (_object_) Specifies the additional metadata or custom information.
    
    Includes all fields of `KeyValuePair`.
    

### FrequencyCaps

Specifies the frequency caps on the units for a line item.

*   `maxImpressions` (_integer_) Specifies the maximum number of impressions for a line item.  
    Example: `1000`.
*   `numTimeUnits` (_integer_) Specifies the maximum number of time units for a line item.  
    Example: `5`.
*   `timeUnit` (_string_) Specifies the type of the time unit as provided by the numTimeUnits property.  
    Allowed values: `Minute`, `Hour`, `Day`, `Week`, `Month`, `Lifetime`. Example: `Hour`.
*   `additionalFields` (_object_) Specifies the additional metadata or custom information.
    
    Includes all fields of `KeyValuePair`.
    

### PricingSpecs

Specifies the pricing specifications of a line item.

*   `costPerUnit` (_object_, required) Specifies the cost of one AD space specification.
    
    Includes all fields of `CurrencyInfo`.
    
*   `valueCostPerUnit` (_object_) Optional. Only required for GAM.
    
    Includes all fields of `CurrencyInfo`.
    
*   `costType` (_string_, required) Specifies the type of the cost, such as cost per click and cost per impression.  
    Example: `CPM`.
*   `discountType` (_string_) Specifies the type of discount specified by the discount field. A discountType value of 'Percentage' with discount value of 15 means the discount provided is 15%.  
    Allowed values: `Absolute`, `Percentage`. Example: `Percentage`.
*   `discount` (_number_) Specifies the value of the discount.  
    Example: `15`.
*   `mediaChannelRate` (_array of object_) Specifies the list of rates based on a media channel and region.
    
    Includes all fields of `MediaChannelRate`.
    
*   `totalCost` (_object_, required) Specifies the total cost of the line item based on the total requested units.
    
    Includes all fields of `CurrencyInfo`.
    
*   `additionalFields` (_object_) Specifies the additional metadata or custom information.
    
    Includes all fields of `KeyValuePair`.
    

### OrderLineBillingSpecs

Specifies the billing specifications of a line item.

*   `billingModeType` (_string_) Specifies the billing mode of a line item.  
    Example: `Threshold`.
*   `billingModeTypeCode` (_string_) Specifies the billing mode of a line item if the type is "Others'.  
    Example: `Usage`.
*   `additionalFields` (_object_) Specifies the additional metadata or custom information.
    
    Includes all fields of `KeyValuePair`.
    

### Goal

Specifies the goals related to a line item.

*   `goalType` (_string_, required) Specifies the goal type of a line item.  
    Allowed values: `Lifetime`, `Daily`, `Other`. Example: `Daily`.
*   `goalTypeCode` (_string_) Specifies the code of goal type of a line item if the type is 'Others'.  
    Example: `Weekly`.
*   `goalUnitType` (_string_, required) Specifies the unit type of the goals for a line item.  
    Allowed values: `Impression`, `Click`, `Other`. Example: `Click`.
*   `goalUnitTypeCode` (_string_) Specifies the code of the unit type if the unit type is 'Others'.  
    Example: `Action`.
*   `goalUnits` (_number_, required) Specifies the count of units as specified by the unitType property.  
    Example: `2000`.
*   `primary` (_boolean_) Specifies whether the goal is primary. The default value is false.  
    Example: `True`.
*   `additionalFields` (_object_) Specifies the additional metadata or custom information.
    
    Includes all fields of `KeyValuePair`.
    

### LineItemQuantity

Represents the quantity details of a line item.

*   `totalQuantity` (_integer_, required) Specifies the number of line items to be added.  
    Example: `12`.
*   `quantityBreakdownByDate` (_array of object_) Specifies the total quantity breakdown by date range.
    
    Includes all fields of `KeyValuePair`.
    
*   `totalQuantityPeriodType` (_string_) Specifies the period type of the total quantity mentioned by totalQuantity field.  
    Example: `weekly`.
*   `totalQuantityType` (_string_) Specifies the type of which the quantity is mentioned.  
    Example: `Impressions`.
*   `additionalFields` (_object_) Specifies the additional metadata or custom information.
    
    Includes all fields of `KeyValuePair`.
    

### AdCreatives

Specifies the details of an AD creative.

*   `height` (_string_, required) Specifies the height of the AD creative.  
    Example: `970`.
*   `width` (_string_, required) Specifies the width of the AD creative.  
    Example: `70`.
*   `adServerCreativeId` (_string_) Specifies the unique identifier of the AD creative.  
    Example: `283718`.
*   `adServerCreativeRunTime` (_string_) Specifies the runtime of the AD creative.  
    Example: `400`.
*   `adServerCreativeType` (_string_) Specifies the type of the AD creative.  
    Example: `Bookend`.
*   `adCreativeUOM` (_string_) Specifies the unit of measure for an ad creative.  
    Example: `Pixels`.
*   `companions` (_array of object_) Specifies the additional metadata or custom information.
    
    _Example_
    
    ```
    [
      {
        "key": "temp",
        "value": {
          "adCreativeUOM": "Pixels",
          "width": 90,
          "height": 120
        }
      }
    ]
    ```
    
    Includes all fields of `KeyValuePair`.
    
*   `attributes` (_object_) Specifies the additional metadata or custom information.
    
    Includes all fields of `KeyValuePair`.
    
*   `additionalFields` (_object_) Specifies the additional metadata or custom information.
    
    Includes all fields of `KeyValuePair`.
    

### TargetSegmentItem

Specifies the details of a targeting segment.

*   `segmentCode` (_string_) Specifies a segment code.  
    Example: `SlotType`.
*   `segmentName` (_string_) Specifies a segment name.  
    Example: `SlotType`.
*   `segmentValues` (_array of object_) Specifies the values of the targeting segment, which contains a list of the segment keys and their corresponding targeting values.
    
    Includes all fields of `KeyValuePair`.
    

### CustomTargetingDefinition

Specifies the custom targeting information other than daypart or geographic targeting.

*   `targetingSegmentDefinition` (_array of object_) Specifies the list of the targeting segments related to a category.
    
    Includes all fields of `TargetSegmentItem`.
    
*   `categoryCode` (_string_) Specifies the code of the category, which is a unique identifier for a custom targeting information.  
    Example: `Audience`.
*   `categoryName` (_string_) Specifies the name of the targeting category.  
    Example: `Audience Segment`.

### MediaChannelRate

Specifies the rate of a specific channel or region.

*   `channelCode` (_string_) Specifies the code of the media channel.  
    Example: `SONY`.
*   `regionCode` (_string_) Specifies the code of the region.  
    Example: `NYC`.
*   `lineRate` (_object_) Specifies the rate of the line item with respect to a channel or a region.
    
    Includes all fields of `CurrencyInfo`.